package br.pucrs.ages.victims.auth.service

import br.pucrs.ages.victims.auth.domain.dto.JwtTokenDTO
import br.pucrs.ages.victims.auth.exception.AuthenticationException
import br.pucrs.ages.victims.auth.repository.AuthRepository
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.stereotype.Service

@Service
class AuthService(
    @Autowired
    private val authRepository: AuthRepository
) {
    fun login(username: String, password: String): JwtTokenDTO {
        try {
            return authRepository.authenticate(username, password)
        } catch (exception: Exception) {
            throw AuthenticationException("CPF ou senha inválidos")
        }
    }
}
