package br.pucrs.ages.victims.auth.web

import br.pucrs.ages.victims.auth.domain.User
import br.pucrs.ages.victims.auth.web.representation.request.RegisterRequestModel
import io.swagger.v3.oas.annotations.Operation
import io.swagger.v3.oas.annotations.responses.ApiResponse
import io.swagger.v3.oas.annotations.responses.ApiResponses
import io.swagger.v3.oas.annotations.tags.Tag
import org.springframework.http.ResponseEntity

@Tag(name = "Usuário", description = "Endpoints de usuário")
interface UserApi {

    @Operation(summary = "Cria um usuário no keycloak e retorna o id usado pela aplicação")
    @ApiResponses(
        value = [
            ApiResponse(responseCode = "200", description = "Usuário criado com sucesso"),
            ApiResponse(responseCode = "400", description = "Payload inválido"),
            ApiResponse(responseCode = "500", description = "Erro interno")
        ]
    )
    fun create(payload: RegisterRequestModel): ResponseEntity<User>
}