package br.pucrs.ages.victims.auth.web.controller

import br.pucrs.ages.victims.auth.domain.dto.JwtTokenDTO
import br.pucrs.ages.victims.auth.service.AuthService
import br.pucrs.ages.victims.auth.web.AuthApi
import br.pucrs.ages.victims.auth.web.representation.request.LoginRequestModel
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.http.ResponseEntity
import org.springframework.web.bind.annotation.PostMapping
import org.springframework.web.bind.annotation.RequestBody
import org.springframework.web.bind.annotation.RestController

@RestController
class AuthController(
    @Autowired
    private val authService: AuthService
) : AuthApi {

    @PostMapping("/login")
    override fun login(@RequestBody payload: LoginRequestModel): ResponseEntity<JwtTokenDTO> {
        val authenticationDTO = authService.login(payload.username, payload.password)
        return ResponseEntity.ok(authenticationDTO)
    }
}