package br.pucrs.ages.victims.auth.web.controller

import br.pucrs.ages.victims.auth.domain.User
import br.pucrs.ages.victims.auth.service.UserService
import br.pucrs.ages.victims.auth.web.UserApi
import br.pucrs.ages.victims.auth.web.representation.request.RegisterRequestModel
import jakarta.validation.Valid
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.http.HttpStatus
import org.springframework.http.ResponseEntity
import org.springframework.web.bind.annotation.PostMapping
import org.springframework.web.bind.annotation.RequestBody
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController

@RestController
@RequestMapping("/users")
class UserController(

    @Autowired
    val userService: UserService

) : UserApi {
    @PostMapping
    override fun create(@Valid @RequestBody payload: RegisterRequestModel): ResponseEntity<User> {
        val user = userService.create(payload)
        return ResponseEntity.status(HttpStatus.CREATED).body(user)
    }
}