package br.pucrs.ages.victims.auth.web.representation.request

import jakarta.validation.constraints.Email
import jakarta.validation.constraints.NotBlank
import jakarta.validation.constraints.Size

class RegisterRequestModel(

    @field:NotBlank(message = "O nome é obrigatório")
    val name: String = "",

    @field:NotBlank(message = "O CPF é obrigatório")
    @field:Size(min = 11, max = 11, message = "O CPF deve ter 11 caracteres")
    val cpf: String = "",

    @field:NotBlank(message = "O email é obrigatório")
    @field:Email(message = "O email deve ser válido")
    val email: String = "",

    @field:NotBlank(message = "O telefone é obrigatório")
    @field:Size(min = 11, max = 11, message = "O telefone deve ter 11 dígitos")
    val phoneNumber: String = "",

    @field:NotBlank(message = "A senha é obrigatória")
    @field:Size(min = 8, max = 255, message = "A senha deve ter entre 8 e 255 dígitos")
    val password: String = "",

    @field:NotBlank(message = "A senha de segurança é obrigatória")
    @field:Size(min = 8, max = 255, message = "A senha de segurança deve ter entre 8 e 255 caracteres")
    val securityPassword: String = ""
)