package br.pucrs.ages.victims.auth.web.error

import br.pucrs.ages.victims.auth.exception.ExistingResourceException
import br.pucrs.ages.victims.auth.exception.ValidationException
import org.junit.jupiter.api.Test

import org.junit.jupiter.api.Assertions.*
import org.springframework.http.HttpStatus

class GlobalExceptionHandlerTest {

    private val globalExceptionHandler = GlobalExceptionHandler()

    @Test
    fun `should handle ExistingResourceException`() {
        val exceptionMessage = "Resource already exists"
        val exceptionStatus = HttpStatus.CONFLICT
        val ex = ExistingResourceException(exceptionMessage)

        val responseEntity = globalExceptionHandler.handleRestException(ex)

        assertEquals(exceptionStatus, responseEntity.statusCode)
        assertEquals(exceptionMessage, responseEntity.body?.message)
    }

    @Test
    fun `should handle ValidationException`() {
        val exceptionMessage = "Validation failed"
        val exceptionStatus = HttpStatus.BAD_REQUEST
        val ex = ValidationException(exceptionMessage)

        val responseEntity = globalExceptionHandler.handleRestException(ex)

        assertEquals(exceptionStatus, responseEntity.statusCode)
        assertEquals(exceptionMessage, responseEntity.body?.message)
    }
}